//==============================================================================
// (c) 2001-2004  Trymedia Systems, Inc.
//------------------------------------------------------------------------------
// Project : HTML - ActiveMARK integration
// File    : am_include.js
// Author  : Trymedia Systems Inc.
//  $Change: 25217 $
//
//------------------------------------------------------------------------------
// DO NOT EDIT THIS FILE.
// THIS FILE WILL BE OVERWRITTEN AT PACKAGING TIME
//==============================================================================

//==============================================================================
// AM_Close_Browser()
//
// Closes HTML page and quits (without launching trial).
//
// DO NOT EDIT FUNCTION. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================
function AM_Close_Browser()  {
  if (simulation) {
    external.close(purchase);
  } else {
    if (confirm("This button will close the browser.\n"                         +
                "This message will go away once your executable has been "      +
                "packaged.\n"                                         +
                "Press OK to close this window.")) {
      document.location = window.location.href;
      window.close();
    } else {
      document.location = window.location.href;
    }
  }
}

//==============================================================================
// AM_Start_Trial()
//
// Starts trial mode (closes HTML page)
//
// DO NOT EDIT FUNCTION. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================
function AM_Start_Trial()  {
  if (simulation) {
    external.close(purchase);
  } else {
    if (confirm("This button will start the main executable in trial mode.\n"   + 
                "This message will go away once your executable has been "      +
                "packaged.\n"                                         +
                "Press OK to close this window.")) {
      document.location = window.location.href;
      window.close();
    } else {
      document.location = window.location.href;
    }
  }
}

//==============================================================================
// AM_Get_Contentid()
//
// Retrieves the contentid for the current product
//
// WARNING: The contentid provided by this file will be overwritten at
//          packaging time.
//
// DO NOT EDIT FUNCTION. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================
function AM_Get_Contentid() {
  return "badf00dbadf00dbadf00dbadf00dbadf";
}

//==============================================================================
// AM_Compose_URL(url)
//
// You need to call AM_Compose_URL whenever linking to *ANY* HTML page HTML
// from the offline HTML pages.
//
// AM_Compose_URL will append some additional ActiveMARK-related parameters to
// the provided URL that ActiveMARK needs.
//
// Linking to URLs that have not gone thru this function will cause unpredicted 
// behavior.
//
// Parameters:
//
// IN:  desired URL
// OUT: URL
//
// DO NOT EDIT FUNCTION. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================
function AM_Compose_URL(url) {
  var returnValue;
  if (url.indexOf("//") == -1) { // url is a relative URL
    // Get current url, remove url parameters (if any), substitute the
    // current page using the given relative url and finally add the url
    // parameters again
    var hrefTokens = window.location.href.split ("?");
    if (hrefTokens == null) returnValue = window.location.href;
    else returnValue = hrefTokens[0];
    
    returnValue = returnValue.replace(/\\/g, "/");
    returnValue = returnValue.replace(/\/\//g, "\\");
    var tokens  = returnValue.split(/\//);
    tokens[tokens.length - 1] = url;
    returnValue = tokens.join("/");
    returnValue = returnValue.replace(/\\/g, "\/\/");  
  } else { // url is an absolute URL
    returnValue = url;
  }
  // Add URLParameters
  if (URLParameters) {
    if (returnValue.indexOf("?") == -1) {
      returnValue = returnValue + "?" + strparam;
    } else {
      returnValue = returnValue + "&" + strparam;
    }
  }
  if (returnValue.indexOf("?") != -1) {
    // Remove duplicates
    // split the pairs (Break at &)
    var uniqueParams= new Array();
    var parameters = new String();
    var pairs = new Array();
    var ini = 0;
    var y = 0;
    var params = returnValue.substr(returnValue.indexOf("?") + 1,
                                    returnValue.length - returnValue.indexOf("?"));
    for (i=0; i < params.length; i++) {
      if(params.charAt(i) =="&"){ 
        pairs[y]=params.substring(ini,i);
        y++;
        ini = i+1;
      }    
    }
    pairs[y]=params.substring(ini,returnValue.length);
    for(var i = 0; i < pairs.length; i++) {
      //get the position for the query environment string
      var pos = pairs[i].indexOf('=');
      if (pos == -1) continue; //if not found, skip
      //get the name
      var name = unescape(pairs[i].substring(0,pos));
      //get the value
      var value = unescape(pairs[i].substring(pos+1));
      // Add it if not defined (to give preferences to parameters in url)
      if (!uniqueParams[name]) {
        uniqueParams[name] = value;
        if (parameters.length == 0) {
          parameters = urlescape(name) + "=" + urlescape(value);
        } else {
          parameters += "&" + urlescape(name) + "=" + urlescape(value);
        }
      }
    }
    returnValue = returnValue.substr(0, returnValue.indexOf("?") + 1) + parameters;
  }  
  return returnValue;
}

//==============================================================================
// AM_Init_Purchase(formObject, connectPage, connectingPage)
//
// Invoke this function to prepare the form posting the data to start
// the purchase process.
//
// Parameters:
// - formObject     -> form posting the data
// - connectPage    -> Optional. If given, Internet connection will be checked
//                     before actually posting the data to the server. If
//                     Internet connection available, it will post the data to
//                     the server (directly, or using connectingPage if given).
//                     If no Internet connection, it will tell users to connect
//                     to the internet using this HTML page, giving them the
//                     opportunity to connect from that page. If not given, the
//                     form will directly post the data to the server, resulting
//                     in a 404 (Page Not Found) error if there is no Internet
//                     connection
// - connectingPage -> Optional. If both connectPage and connectingPage given,
//                     it will be the HTML page to display while posting the
//                     data to the server
//
// DO NOT EDIT FUNCTION. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================
function AM_Init_Purchase(formObject, connectPage, connectingPage) {
  var sign;

  if (connectPage) {
    if (connectPage.indexOf("?") == -1) {
      sign = "?";
    } else {
      sign = "&";
    }
    formObject.action = AM_Compose_URL(connectPage + sign +
                          'url=saved.html&referrer=' +
                          urlescape(window.location.href) + '&action=purchase');
  } else {
    formObject.action = AM_Compose_URL('saved.html?referrer=' +
                          urlescape(window.location.href));
  }
}

//==============================================================================
// AM_Init_Relicense(formObject, connectPage, connectingPage)
//
// Invoke this function to prepare the form posting the data to start the
// "renew license" process.
//
// Parameters:
// - formObject     -> form posting the data
// - connectPage    -> Optional. If given, Internet connection will be checked
//                     before actually posting the data to the server. If
//                     Internet connection available, it will post the data to
//                     the server (directly, or using connectingPage if given).
//                     If no Internet connection, it will tell users to connect
//                     to the internet using this HTML page, giving them the
//                     opportunity to connect from that page. If not given, the
//                     form will directly post the data to the server, resulting
//                     in a 404 (Page Not Found) error if there is no Internet
//                     connection
// - connectingPage -> Optional. If both connectPage and connectingPage given,
//                     it will be the HTML page to display while posting the
//                     data to the server
//
// DO NOT EDIT FUNCTION. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================
function AM_Init_Relicense(formObject, connectPage, connectingPage) {
  var sign;
  if (connectPage) {
    if (connectPage.indexOf("?") == -1) {
      sign = "?";
    } else {
      sign = "&";
    }
    formObject.action = AM_Compose_URL(connectPage + sign +
                          'url=saved.html&referrer=' +
                          urlescape(window.location.href) + '&action=relicense');
  } else {
    formObject.action = AM_Compose_URL('saved.html?referrer=' +
                          urlescape(window.location.href));
  }
}

//==============================================================================
// AM_Init_GetBnDLicense(formObject, connectPage, connectingPage)
//
// Invoke this function to prepare the form posting the data to start the
// "Buy and Download" process.
//
// Parameters:
// - formObject     -> form posting the data
// - connectPage    -> Optional. If given, Internet connection will be checked
//                     before actually posting the data to the server. If
//                     Internet connection available, it will post the data to
//                     the server (directly, or using connectingPage if given).
//                     If no Internet connection, it will tell users to connect
//                     to the internet using this HTML page, giving them the
//                     opportunity to connect from that page. If not given, the
//                     form will directly post the data to the server, resulting
//                     in a 404 (Page Not Found) error if there is no Internet
//                     connection
// - connectingPage -> Optional. If both connectPage and connectingPage given,
//                     it will be the HTML page to display while posting the
//                     data to the server
//
// DO NOT EDIT FUNCTION. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================
function AM_Init_GetBnDLicense(formObject, connectPage, connectingPage) {
  var sign;
  if (connectPage) {
    if (connectPage.indexOf("?") == -1) {
      sign = "?";
    } else {
      sign = "&";
    }
    formObject.action = AM_Compose_URL(connectPage + sign +
                          'url=saved.html&referrer=' +
                          urlescape(window.location.href) + '&action=getbnd');
  } else {
    formObject.action = AM_Compose_URL('saved.html?referrer=' +
                          urlescape(window.location.href));
  }
}

//==============================================================================
// AM_Init_Csc(formObject, connectPage, connectingPage)
//
// Invoke this function to prepare the form posting the data to go
// to the "Customer Support Center"
//
// Parameters:
// - formObject     -> form posting the data
// - connectPage    -> Optional. If given, Internet connection will be checked
//                     before actually posting the data to the server. If
//                     Internet connection available, it will post the data to
//                     the server (directly, or using connectingPage if given).
//                     If no Internet connection, it will tell users to connect
//                     to the internet using this HTML page, giving them the
//                     opportunity to connect from that page. If not given, the
//                     form will directly post the data to the server, resulting
//                     in a 404 (Page Not Found) error if there is no Internet
//                     connection
// - connectingPage -> Optional. If both connectPage and connectingPage given,
//                     it will be the HTML page to display while posting the
//                     data to the server
//
// DO NOT EDIT FUNCTION. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================
function AM_Init_Csc(formObject, connectPage, connectingPage) {
  var sign;
  if (connectPage) {
    if (connectPage.indexOf("?") == -1) {
      sign = "?";
    } else {
      sign = "&";
    }
    formObject.action = AM_Compose_URL(connectPage + sign +
                          'url=saved.html&referrer=' +
                          urlescape(window.location.href) + '&action=csc');
  }
}

//==============================================================================
// AM_Init_Activation(formObject, connectPage, connectingPage)
//
// Invoke this function to prepare the form posting the data to start
// the activation process.
//
// Parameters:
// - formObject     -> form posting the data
// - connectPage    -> Optional. If given, Internet connection will be checked
//                     before actually posting the data to the server. If
//                     Internet connection available, it will post the data to
//                     the server (directly, or using connectingPage if given).
//                     If no Internet connection, it will tell users to connect
//                     to the internet using this HTML page, giving them the
//                     opportunity to connect from that page. If not given, the
//                     form will directly post the data to the server, resulting
//                     in a 404 (Page Not Found) error if there is no Internet
//                     connection
// - connectingPage -> Optional. If both connectPage and connectingPage given,
//                     it will be the HTML page to display while posting the
//                     data to the server
//
// DO NOT EDIT FUNCTION. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================
function AM_Init_Activation(formObject, connectPage, connectingPage) {
  var sign;

  if (connectPage) {
    if (connectPage.indexOf("?") == -1) {
      sign = "?";
    } else {
      sign = "&";
    }
    formObject.action = AM_Compose_URL(
      connectPage + sign + 'url=saved.html&referrer=' + 
      urlescape(window.location.href) + '&action=product_activation'
    );
  } else {
    formObject.action = AM_Compose_URL('saved.html?referrer=' +
                          urlescape(window.location.href));
  }
}

//==============================================================================
// AM_Connect(formObject)
//
// Invoke this function to try to connect to the internet.
//
// If successful, it will redirect the customer (using the optional
// connectingPage if given) to start the purchase, reactivation,
// Buy and Download or go to the CSC, depending on the AM_Init
// method called. If connection fails, it will send the customer again
// to the connectPage.
//
// You can only use this function in the page specified as
// connectPage in AM_Init_Purchase, AM_Init_Relicense,
// AM_Init_GetBnDLicense or AM_Init_CSC methods
//
// Parameters:
// - formObject  -> form posting the data
//
// DO NOT EDIT FUNCTION. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================
function AM_Connect(formObject) {
  if (param.connect == 1 && param.url && param.action) {
    if (param.action == "csc") {
      alert("This button will check the Internet connection.\nIf not connected, " +
            "it will try to connect you to the Internet\n" +
            "If conected, it will send you to the Customer Support Page.\n" + 
            "This message will go away once your executable has been "      +
            "packaged.\n");
      window.close();
    } else if (param.action=="getbnd") {
      alert("This button will check the Internet connection.\nIf not connected, " +
            "it will try to connect you to the Internet\n" +
            "If conected, it will send you to the online page to activate the content.\n" + 
            "This message will go away once your executable has been "      +
            "packaged.\n");
      formObject.action = AM_Compose_URL("saved.html");
   } else if (param.action == "purchase" || param.action == "relicense" || param.action == "product_activation") {
      alert("This button will check the Internet connection.\nIf not connected, " +
            "it will try to connect you to the Internet\n" +
            "If conected, it will send you to the online page to begin the "+param.action+" process.\n" + 
            "This message will go away once your executable has been "      +
            "packaged.\n");
      if (param.url.indexOf("?") == -1) {
        formObject.action = AM_Compose_URL(param.url + "?purchase=1");
        formObject.submit();
      } else {
        formObject.action = AM_Compose_URL(param.url + "&purchase=1");
        formObject.submit();
      }
    }
  } else {
    if (window.location.href.indexOf("?") == -1) {
      formObject.action = AM_Compose_URL(window.location.href + "?connect=1");
    } else {
      formObject.action = AM_Compose_URL(window.location.href + "&connect=1");
    }
  }
}

//==============================================================================
// AM_Navigate(formObject)
//
// Invoke this function to send the customer (using the
// optional connectingPage if given) to start the purchase,
// reactivation, Buy and download or to go to the CSC without
// checking the Internet connection.
//
// You can only use this function in the page specified as
// connectPage in AM_Init_Purchase, AM_Init_Relicense,
// AM_Init_GetBnDLicense or AM_Init_CSC methods
//
// Parameters:
// - formObject  -> form posting the data
//
// DO NOT EDIT FUNCTION. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================
function AM_Navigate(formObject) {
  if (param.navigate == 1 && param.url && param.action) {
    if (param.action == "csc") {
      alert("This button will check the Internet connection.\nIf not connected, " +
            "it will try to connect you to the Internet\n" +
            "If conected, it will send you to the Customer Support Page.\n" + 
            "This message will go away once your executable has been "      +
            "packaged.\n");
      window.close();
    } else if (param.action=="getbnd") {
      alert("This button will check the Internet connection.\nIf not connected, " +
            "it will try to connect you to the Internet\n" +
            "If conected, it will send you to the online page to activate the content.\n" + 
            "This message will go away once your executable has been "      +
            "packaged.\n");
      formObject.action = AM_Compose_URL("saved.html");
   } else if (param.action == "purchase" || param.action == "relicense" || param.action == "product_activation") {
      alert("This button will check the Internet connection.\nIf not connected, " +
            "it will try to connect you to the Internet\n" +
            "If conected, it will send you to the online page to begin the "+param.action+" process.\n" + 
            "This message will go away once your executable has been "      +
            "packaged.\n");
      if (param.url.indexOf("?") == -1) {
        formObject.action = AM_Compose_URL(param.url + "?purchase=1");
        formObject.submit();
      } else {
        formObject.action = AM_Compose_URL(param.url + "&purchase=1");
        formObject.submit();
      }
    }
  } else {
    if (window.location.href.indexOf("?") == -1) {
      formObject.action = AM_Compose_URL(window.location.href + "?navigate=1");
    } else {
      formObject.action = AM_Compose_URL(window.location.href + "&navigate=1");
    }
  }
}

//==============================================================================
// The following code checks that the current URL has the appropriate parameters
// If 'affiliate' parameter not present, it means the page is not linked using 
// AM_Compose_URL function
//
// DO NOT EDIT. THIS FILE WILL BE OVERWRITTEN.
//==============================================================================

//get query string
var param  = new Object();
var strquery = top.parent.location.search.substring(1); 
//split the pairs (Break at &)
var pairs = new Array();
var ini = 0;
var y = 0;
for (i=0; i < strquery.length; i++) {
  if(strquery.charAt(i) =="&"){ 
    pairs[y]=strquery.substring(ini,i);
    y++;
    ini = i+1;
  }    
}
pairs[y]=strquery.substring(ini,strquery.length);
for(var i = 0; i < pairs.length; i++) {
  //get the position for the query environment string
  var pos = pairs[i].indexOf('=');
  if (pos == -1) continue; //if not found, skip
  //get the name
  var name = unescape(pairs[i].substring(0,pos));
  //get the value
  var value = unescape(pairs[i].substring(pos+1));
  param[name] = value;
}

var strparam = window.location.href;
var URLParameters = 0;
if (strparam.indexOf("?") != -1) {
  strparam = strparam.substr(strparam.indexOf("?") + 1, strparam.length - strparam.indexOf("?"));
  URLParameters = 1;
}
var simulation = 0;
var purchase   = 0;
if (param.purchase == "1") {
  purchase = 2;
}
if (param.affiliate) {
  if (param.affiliate == "simulate") {
    simulation = 1;
  }
} else {
  var detect = navigator.userAgent.toLowerCase();
  var isMSIE = detect.indexOf("msie") + 1;
  var  version = detect.charAt(isMSIE + 4);
  if ((isMSIE) && (version > 4 )) {
    alert("This page is not link the previous one using AM_Compose_URL "     + 
          "function.\n"                                                      +
          "Make sure that:\n"                                                +
          " - You use AM_Compose_URL to create links between pages\n"        +
          "This error message will go away once your executable has been "   +
          "packaged.");
  }
}

function urlescape(parameter) {
  var value = escape(parameter);
  value = value.replace(/\//g, "%2f");
  return value;
}
